package cn.hanghui.outapi.platform.common.controller;

import cn.hanghui.outapi.platform.common.config.JwtConfig;
import cn.hanghui.outapi.platform.common.entity.rest.RestCode;
import cn.hanghui.outapi.platform.common.exception.CommonException;
import cn.hutool.jwt.JWT;
import cn.hutool.jwt.JWTPayload;
import cn.hutool.jwt.JWTUtil;

import javax.servlet.http.HttpServletRequest;

/**
 * @author shisl
 * @package cn.hanghui.outapi.platform.common.controller
 * @class BaseController
 * @date 2023/5/10 下午3:10
 * @description
 */
public class BaseController {

    /**
     * 获取登录用户名
     *
     * @param request
     * @return
     */
    public String getUserName(HttpServletRequest request) {
        String token = request.getHeader(JwtConfig.JWT_HEADER);
        try {
            JWT jwt = JWTUtil.parseToken(token);
            JWTPayload payload = jwt.getPayload();
            return payload.getClaim("name").toString();
        } catch (Exception e) {
            throw new CommonException(RestCode.UNAUTHORIZED.getMsg());
        }
    }
}
