package cn.hanghui.outapi.platform.tenant.entity.po;

import cn.hanghui.outapi.platform.common.entity.po.Base;
import cn.hanghui.outapi.platform.tenant.entity.dto.ManualInIdCardAuthDto;
import cn.hanghui.outapi.platform.tenant.entity.dto.ZoloConfigDto;
import cn.hanghui.outapi.platform.tenant.typehandle.ManualInIdCardAuthHandler;
import cn.hanghui.outapi.platform.tenant.typehandle.ZoloConfigDtoHandler;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;

import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;

import java.io.Serializable;

import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * <p>
 * 设备
 * </p>
 *
 * @author wxg
 * @since 2023-12-29
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName(value = "device_template", autoResultMap = true)
@ApiModel(value = "DeviceTemplate对象", description = "设备")
public class DeviceTemplate extends Base {

    @ApiModelProperty(value = "模版名称")
    @TableField("template_name")
    private String templateName;

    @ApiModelProperty(value = "商户平台id")
    @TableField("tenant_id")
    private Long tenantId;

    @ApiModelProperty(value = "场景id")
    @TableField("scene_id")
    private Long sceneId;

    @ApiModelProperty(value = "用户库id")
    @TableField("user_lib_id")
    private Long userLibId;

    @ApiModelProperty(value = "模式public close elasticity 三个参数分别代表 开放 封闭 弹性")
    @TableField("mode")
    private String mode;

    @ApiModelProperty(value = "是否启用支付宝人脸能力 默认：true")
    @TableField("use_alipay_face")
    private Boolean useAlipayFace;

    @ApiModelProperty(value = "联动平台地址")
    @TableField("linkage_ads")
    private String linkageAds;

    @ApiModelProperty(value = "刷脸成功结果页时长 1-10 默认值2")
    @TableField("success_page_time")
    private Integer successPageTime;

    @ApiModelProperty(value = "刷脸失败结果页时长 1-10 默认值5")
    @TableField("fail_page_time")
    private Integer failPageTime;

    @ApiModelProperty(value = "zoloConfig摄像头配置 ZoloConfigDto")
    @TableField(value = "zolo_config", typeHandler = ZoloConfigDtoHandler.class)
    private ZoloConfigDto zoloConfig;

    @ApiModelProperty(value = "是否启用身份证功能 默认：true")
    @TableField("use_idcard")
    private Boolean useIdcard;

    @ApiModelProperty(value = "是否人证比对 默认：false")
    @TableField("use_person_card")
    private Boolean usePersonCard;

    @ApiModelProperty(value = "是否启用二维码功能 默认：true")
    @TableField("use_qrcode")
    private Boolean useQrcode;

    @ApiModelProperty(value = "是否启用联动平台 默认：true")
    @TableField("use_linkage")
    private Boolean useLinkage;

    @ApiModelProperty(value = "刷脸模式: 点击/自动 click/auto  默认 auto")
    @TableField("face_mode")
    private String faceMode;

    @ApiModelProperty(value = "点击刷脸按钮文本  默认 点击开始刷脸核验")
    @TableField("click_button_text")
    private String clickButtonText;

    @ApiModelProperty(value = "是否抓拍人脸 默认：false")
    @TableField("is_capture_face")
    private Boolean isCaptureFace;

    @ApiModelProperty(value = "need1V1是否使用支付宝刷证提示页 默认：true")
    @TableField("is_need1_v1")
    private Boolean isNeed1V1;

    @ApiModelProperty(value = "开门信号: 继电器/RS232 default/RS232 默认：default")
    @TableField("use_serial_port")
    private String useSerialPort;

    @ApiModelProperty(value = "RS232默认信号")
    @TableField("signal_no")
    private String signalNo;

    @ApiModelProperty(value = "补光灯: 自动 auto 默认:auto")
    @TableField("light_mode")
    private String lightMode;

    @ApiModelProperty(value = "语音音量 0-100 默认值80")
    @TableField("volume")
    private Integer volume;

    @ApiModelProperty(value = "成功语音 默认: 请通行")
    @TableField("suc_voice")
    private String sucVoice;

    @ApiModelProperty(value = "成功文字 默认: 请通行")
    @TableField("suc_text")
    private String sucText;

    @ApiModelProperty(value = "失败语音 默认: 比对失败,请联系现场工作人员")
    @TableField("fail_voice")
    private String failVoice;

    @ApiModelProperty(value = "失败文字 默认: 比对失败,请联系现场工作人员")
    @TableField("fail_text")
    private String failText;

    @ApiModelProperty(value = "隐藏底部导航栏 默认: false")
    @TableField("hide_navigation_bar")
    private Boolean hideNavigationBar;

    @ApiModelProperty(value = "禁止下拉通知栏 默认: false")
    @TableField("forbid_pull_down")
    private Boolean forbidPullDown;

    @ApiModelProperty(value = "首页图片")
    @TableField("home_page_url")
    private String homePageUrl;

    @ApiModelProperty(value = "过渡图片")
    @TableField("transition_page_url")
    private String transitionPageUrl;

    @ApiModelProperty(value = "设备在线状态心跳地址")
    @TableField("heart_tracking_url")
    private String heartTrackingUrl;

    @ApiModelProperty(value = "设备在线状态心跳地址")
    @TableField("transit_push_url")
    private String transitPushUrl;

    @ApiModelProperty(value = "是否显示顶部栏")
    @TableField("show_top_bar")
    private Boolean showTopBar;

    @ApiModelProperty(value = "顶部栏左边显示内容")
    @TableField("left_top_bar_text")
    private String leftTopBarText;

    @ApiModelProperty(value = "顶部栏右边显示内容")
    @TableField("right_top_bar_text")
    private String rightTopBarText;

    @ApiModelProperty(value = "通行方式(passWay): 通用(normal) 进站刷脸全量通行(inStation)  出站刷脸全量通行(outStation) ")
    @TableField("pass_way")
    private String passWay;

    @ApiModelProperty(value = "是否开启年龄限制")
    @TableField("is_open_age_limit")
    private Boolean isOpenAgeLimit;

    @ApiModelProperty(value = "限制区间-开始年龄")
    @TableField("limit_section_start")
    private Integer limitSectionStart;

    @ApiModelProperty(value = "限制区间-结束年龄")
    @TableField("limit_section_end")
    private Integer limitSectionEnd;

    @ApiModelProperty(value = "禁止进入文本")
    @TableField("age_forbid_text")
    private String ageForbidText;

    @ApiModelProperty(value = "设备管理员密码")
    @TableField("mpassword")
    private String mpassword;

    @ApiModelProperty(value = "是否开启护照机 默认: false")
    @TableField("is_open_passport")
    private Boolean isOpenPassport;

    @ApiModelProperty(value = "是否推送门磁信号 默认: false")
    @TableField("is_push_gm")
    private Boolean isPushGM;

    @ApiModelProperty(value = "门磁信号推送地址")
    @TableField("gm_address")
    private String GMAddress;

    @ApiModelProperty(value = "门磁信号推送频率")
    @TableField("gm_frequency")
    private Integer GMFrequency;

    @ApiModelProperty(value = "应用是否自启动 默认: false")
    @TableField("auto_launch")
    private Boolean autoLaunch;

    @ApiModelProperty(value = "应用是否自启动")
    @TableField("use_entry_detector")
    private Boolean useEntryDetector;

    @ApiModelProperty(value = "应用类型id")
    @TableField("application_type_id")
    private Long applicationTypeId;

    @ApiModelProperty(value = "设备型号(硬件)id")
    @TableField("device_model_hardware_id")
    private Long deviceModelHardwareId;

    @ApiModelProperty(value = "设备型号(环境)id")
    @TableField("device_model_environment_id")
    private Long deviceModelEnvironmentId;

    @ApiModelProperty(value = "系统类型 1-蚂蚁OS 2-非蚂蚁OS")
    @TableField("system_type_code")
    private Integer systemTypeCode;
    /**
     * ============================20240103添加===========================
     */
    @ApiModelProperty(value = "在线日志推送地址")
    private String logPushUrl;
    /**
     * @see cn.hanghui.outapi.platform.tenant.entity.enums.CameraTypeEnum
     */
    @ApiModelProperty(value = "摄像头类型 IR-双目  3D-3D结构光 ")
    private String cameraType;
    /**
     * @see cn.hanghui.outapi.platform.tenant.entity.enums.CameraBrandEnum
     */
    @ApiModelProperty(value = "品牌 Normal-通用   Mario-马里奥")
    private String cameraBrand;
    /**
     * ============================20240105添加===========================
     */
    /**
     * @see cn.hanghui.outapi.platform.tenant.entity.enums.EntryFaceModeEnum
     */
    @ApiModelProperty(value = "进场刷脸模式")
    private String entryFaceMode;

    /**
     * @see cn.hanghui.outapi.platform.tenant.entity.enums.UserOutputModeEnum
     */
    @ApiModelProperty(value = "用户信息输出模式  NoOutput:不输出（默认）， AnalogSignal:阅读器模拟信号")
    private String userOutputMode;

    @ApiModelProperty(value = "身份证阅读器品牌 IdCardReaderBrandEnum")
    private Integer idCardReaderBrand;

    /**
     * ============================20240315添加===========================
     */
    @ApiModelProperty(value = "是否设备实名入库 默认false")
    private Boolean authVerifiedFacein;

    @ApiModelProperty(value = "是否开启手动输入证件号 默认false")
    private Boolean manualInIdCard;

    @ApiModelProperty(value = "开启手动输入证件号的密钥信息")
    @TableField(value = "manual_in_id_card_auth", typeHandler = ManualInIdCardAuthHandler.class)
    private ManualInIdCardAuthDto manualInIdCardAuth;
    /**
     * ============================20240327添加===========================
     */
    /**
     * @see cn.hanghui.outapi.platform.tenant.entity.enums.LinkageCheckModeEnum
     */
    @ApiModelProperty(value = "联动平台校验模式 1-通用 2-预检查模式")
    private Integer linkageCheckMode;
    /**
     * @see cn.hanghui.outapi.platform.tenant.entity.enums.ResultPageTemplateEnum
     */
    @ApiModelProperty(value = "结果页模版 1-通用版 2-悬浮版")
    private Integer resultPageTemplate;
    /**
     * ============================20240423添加===========================
     */
    /**
     * @see cn.hanghui.outapi.platform.tenant.entity.enums.RelayOpenModelEnum
     */
    @ApiModelProperty(value = "继电器开门模式 1-开-闭信号 2-开-门磁-闭信息")
    private Integer relayOpenModel;
    @ApiModelProperty(value = "开闭时间间隔（s）")
    private Integer openCloseInterval;
    @ApiModelProperty(value = "信号间间隔（s）")
    private Integer signalInterval;
    @ApiModelProperty(value = "门磁超时时间（s）")
    private Integer gateTimeOut;

    /**
     * ============================20240503添加===========================
     */
    @ApiModelProperty(value = "是否解析身份证照片 0-关闭 1-开启 默认-1")
    private Integer analysisPhoto;
    @ApiModelProperty(value = "是否解析身份证指纹 0-关闭 1-开启 默认-0")
    private Integer analysisFingerprint;
    /**
     * ============================20240506添加===========================
     */
    @ApiModelProperty(value = "同一人刷证间隔时间 取值范围0-20 默认-3")
    private Integer idCardInterval;

    @ApiModelProperty(value = "刷脸信息推送地址")
    private String pushFaceInfoUrl;
}
