package cn.hanghui.outapi.platform.tenant.service.impl;

import cn.hanghui.outapi.platform.tenant.entity.po.*;
import cn.hanghui.outapi.platform.tenant.mapper.*;
import cn.hutool.core.collection.CollUtil;
import com.baomidou.mybatisplus.core.metadata.IPage;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

/**
 * @description:
 * @ClassName CommonImpl
 * @Author WXG
 * @Date 2023/12/28 15:28
 */
@Service
@RequiredArgsConstructor(onConstructor = @__(@Autowired))
public class CommonImpl {

    private final PurchaserMapper purchaserMapper;
    private final ApplicationTypeMapper applicationTypeMapper;
    private final DeviceModelMapper deviceModelMapper;
    private final AmpeMapper ampeMapper;
    private final TenantMapper tenantMapper;
    private final UserLibMapper userLibMapper;
    private final SceneMapper sceneMapper;

    public <T> Map<Long, Purchaser> getPurchaserMap(IPage<T> pageList, Function<T, Long> function) {
        List<T> records = pageList.getRecords();
        if (CollUtil.isEmpty(records)) {
            return new HashMap<>();
        }
        List<Long> idList = records.stream().map(function).collect(Collectors.toList());
        if (CollUtil.isEmpty(idList)) {
            return new HashMap<>();
        }
        List<Purchaser> list = purchaserMapper.selectBatchIds(idList);
        return list.stream().collect(Collectors.toMap(Purchaser::getId, Function.identity()));
    }

    public <T> Map<Long, ApplicationType> getApplicationTypeMap(IPage<T> pageList, Function<T, Long> function) {
        List<T> records = pageList.getRecords();
        if (CollUtil.isEmpty(records)) {
            return new HashMap<>();
        }
        List<Long> idList = records.stream().map(function).collect(Collectors.toList());
        if (CollUtil.isEmpty(idList)) {
            return new HashMap<>();
        }
        List<ApplicationType> list = applicationTypeMapper.selectBatchIds(idList);
        return list.stream().collect(Collectors.toMap(ApplicationType::getId, Function.identity()));
    }

    public <T> Map<Long, DeviceModel> getDeviceModelMap(IPage<T> pageList, Function<T, Long> function) {
        List<T> records = pageList.getRecords();
        if (CollUtil.isEmpty(records)) {
            return new HashMap<>();
        }
        List<Long> idList = records.stream().map(function).collect(Collectors.toList());
        if (CollUtil.isEmpty(idList)) {
            return new HashMap<>();
        }
        List<DeviceModel> list = deviceModelMapper.selectBatchIds(idList);
        return list.stream().collect(Collectors.toMap(DeviceModel::getId, Function.identity()));
    }
    public <T> Map<Long, Ampe> getAmpeMap(IPage<T> pageList, Function<T, Long> function) {
        List<T> records = pageList.getRecords();
        if (CollUtil.isEmpty(records)) {
            return new HashMap<>();
        }
        List<Long> idList = records.stream().map(function).collect(Collectors.toList());
        if (CollUtil.isEmpty(idList)) {
            return new HashMap<>();
        }
        List<Ampe> list = ampeMapper.selectBatchIds(idList);
        return list.stream().collect(Collectors.toMap(Ampe::getId, Function.identity()));
    }
    public <T> Map<Long, Tenant> getTenantMap(IPage<T> pageList, Function<T, Long> function) {
        List<T> records = pageList.getRecords();
        if (CollUtil.isEmpty(records)) {
            return new HashMap<>();
        }
        List<Long> idList = records.stream().map(function).collect(Collectors.toList());
        if (CollUtil.isEmpty(idList)) {
            return new HashMap<>();
        }
        List<Tenant> list = tenantMapper.selectBatchIds(idList);
        return list.stream().collect(Collectors.toMap(Tenant::getId, Function.identity()));
    }
    public <T> Map<Long, UserLib> getUserLibMap(IPage<T> pageList, Function<T, Long> function) {
        List<T> records = pageList.getRecords();
        if (CollUtil.isEmpty(records)) {
            return new HashMap<>();
        }
        List<Long> idList = records.stream().map(function).collect(Collectors.toList());
        if (CollUtil.isEmpty(idList)) {
            return new HashMap<>();
        }
        List<UserLib> list = userLibMapper.selectBatchIds(idList);
        return list.stream().collect(Collectors.toMap(UserLib::getId, Function.identity()));
    }
    public <T> Map<Long, Scene> getSceneMap(IPage<T> pageList, Function<T, Long> function) {
        List<T> records = pageList.getRecords();
        if (CollUtil.isEmpty(records)) {
            return new HashMap<>();
        }
        List<Long> idList = records.stream().map(function).collect(Collectors.toList());
        if (CollUtil.isEmpty(idList)) {
            return new HashMap<>();
        }
        List<Scene> list = sceneMapper.selectBatchIds(idList);
        return list.stream().collect(Collectors.toMap(Scene::getId, Function.identity()));
    }

}
